      SUBROUTINE QSF2D(INT1,INT2,A,B,F,RO,FI,E,L1,L2)
      DIMENSION G(5),L(5),M(5),Q1(5),BC(7)
      INTEGER L1,L2,D
      DOUBLE PRECISION INT1,INT2,A,B,F,RO,FI,E,G,L,M,Q1,BC,I,K,C,W,Z2,
     1EPS,H,Z1,P,R,Q,V,T,S,U,Z,BA,BB,BD,X,Y,DSIN,DCOS,DABS,
     1DMAX1,TDS,TSO,TOF,DFLOAT,HMIN,SYS051
      LOGICAL NI
      DATA  TDS/.2666666666666667D0/,TSO/.7111111111111111D0/,
     *TOF/.1555555555555556D0/
      DATA SYS051/1.1107652D-16/
      DATA HMIN/1.192093D-4/
      NI=A.GT.B
      IF(.NOT.(NI)) GO TO 1
      C=A
      A=B
      B=C
    1 W=B-A
      IF(.NOT.(W.EQ.0.D0)) GO TO 2
      INT1=0.D0
      INT2=0.D0
      GO TO 21
    2 Z2=E/W
      EPS=DABS(E)
      H=1.D0
      Z1=EPS/W
      P=0.D0
      INT1=0.D0
      INT2=0.D0
    3 R=H/2.D0
      Q=W*R
      V=Q*RO
      T=H*.25D0
      DO 4 D=1,5
      L(D)=F(A+W*(P+T*DFLOAT(D-1)))
    4 CONTINUE
    5 IF(DFLOAT(L1+L2).LT.1.5D0.AND.V.LE..25D0) GO TO 6
      S=DABS(L(1)+L(5)-4.D0*(L(2)+L(4))+6.D0*L(3))
      GO TO 8
    6 I=(A+W*(P+R))*RO+FI
      DO 7 D=1,5
      M(D)=L(D)*DSIN(I)
      Q1(D)=L(D)*DCOS(I)
    7 CONTINUE
      I=M(1)+M(5)-4.D0*(M(2)+M(4))+6.D0*M(3)
      S=Q1(1)+Q1(5)-4.D0*(Q1(2)+Q1(4))+6.D0*Q1(3)
      S=DMAX1(DFLOAT(L1)*DABS(I),DFLOAT(L2)*DABS(S))
    8 S=S*R*.42D0
      IF(H.LT.HMIN) GO TO 22
      IF(DABS(S)-Z1) 12,9,9
    9 H=H/2
      IF(H-SYS051*P) 22,22,11
   11 L(5)=L(3)
      L(3)=L(2)
      R=H*.5D0
      V=W*R*RO
      T=H*.25D0
      U=P+T
      L(2)=F(A+W*U)
      L(4)=F(A+W*(U+R))
      GO TO 5
   12 I=(A+W*(P+R))*RO+FI
      Z=DSIN(I)
      BA=DCOS(I)
      Q=W*R
      BB=RO*Q
      BC(4)=DSIN(BB)
      BC(5)=DCOS(BB)
      IF(BB-0.33D0) 13,13,14
   13 BD=BB*0.5D0
      BC(6)=DSIN(BD)
      BC(7)=DCOS(BD)
      G(1)=TDS
      G(2)=TSO*BC(7)
      G(3)=TOF*BC(5)
      G(4)=TSO*BC(6)
      G(5)=TOF*BC(4)
      GO TO 15
   14 BC(1)=1.D0/BB
      BC(2)=BC(1)*BC(1)
      BC(3)=BC(2)*BC(2)
      G(1)=4.D0*BC(2)*(BC(1)*(48.D0*BC(2)-19.D0)*BC(4)+3.D0*(1.D0-
     116.D0*BC(2))*BC(5))
      G(2)=32.D0*BC(2)*(BC(1)*(5.D0-12.D0*BC(2))*BC(4)-(1.D0-12.D0*
     1BC(2))*BC(5))/3.D0
      G(3)=BC(1)*((3.D0-46.D0*BC(2)+96.D0*BC(3))*BC(4)+2.D0*BC(1)*
     1(7.D0-48.D0*BC(2))*BC(5))/3.D0
      G(4)=-16.D0*BC(2)*((1.D0-3.D0*BC(2))*BC(4)+3.D0*BC(1)*BC(5))/
     13.D0
      G(5)=BC(1)*(BC(1)*(11.D0-24.D0*BC(2))*BC(4)-3.D0*(1.D0-8.D0*
     1BC(2))*BC(5))/3.D0
   15 X=G(1)*L(3)+G(2)*(L(2)+L(4))+G(3)*(L(1)+L(5))
      Y=G(4)*(L(4)-L(2))+G(5)*(L(5)-L(1))
      R1=(Z*X+BA*Y)*R
      R2=(BA*X-Z*Y)*R
      INT1=INT1+R1
      INT2=INT2+R2
      IF(P.EQ.P+H) GO TO 22
      P=P+H
      K=1.D0-P
      IF(K.LE.0.0D0) GO TO 20
   16 L(1)=L(5)
      IF(DABS(S)-Z1/32.D0) 17,18,18
   17 H=2*H
   18 IF(H-K) 3,3,19
   19 H=K
      GO TO 3
   22 IERR=65
      CALL UTQS12(IERR,13) 
   20 INT1=INT1*W
      INT2=INT2*W
      IF(.NOT.(NI)) GO TO 21
      C=B
      B=A
      A=C
   21 RETURN
      END
